=== debian/changelog ===
xeus-python (0.15.9+~0.6.0-1) unstable; urgency=medium

  * New upstream version 0.15.9+~0.6.0
  * d/control: switch dependency from xeus-dev to xeus-zmq-dev
  * d/control: add dependency on doctest-dev

 -- Gordon Ball <gordon@chronitis.net>  Mon, 07 Aug 2023 07:50:11 +0000
