=== debian/changelog ===
xeus-python (0.15.10+~0.6.1-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:46:47 +1100

xeus-python (0.15.10+~0.6.1-2build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 03 Mar 2024 05:53:56 +0100

xeus-python (0.15.10+~0.6.1-2) unstable; urgency=medium

  * d/control: build-depend on nlohmann-json3-dev 3.11.3, xeus-zmq 1.1.1-2;
    this should resolve an ABI issue caused by xeus exposing nlohmann::json
    (Closes: #1061007)

 -- Gordon Ball <gordon@chronitis.net>  Sun, 11 Feb 2024 22:27:04 +0100

xeus-python (0.15.10+~0.6.1-1) unstable; urgency=medium

  * New upstream version 0.15.10+~0.6.1

 -- Gordon Ball <gordon@chronitis.net>  Thu, 05 Oct 2023 12:43:30 +0000
