=== debian/control ===
Source: xeus-python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Gordon Ball <gordon@chronitis.net>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cmake,
               pkg-config,
               libzmq3-dev,
               xeus-zmq-dev (>= 1.1.1-2~),
               xtl-dev (>= 0.7~),
               nlohmann-json3-dev (>= 3.11.3~),
               pybind11-dev (>= 2.10.3~),
               pybind11-json-dev (>= 0.2.8~),
               doctest-dev,
               python3-dev,
               python3-setuptools,
Standards-Version: 4.6.2
Section: science
Homepage: https://github.com/jupyter-xeus/xeus-python
Vcs-Git: https://salsa.debian.org/science-team/xeus-python.git
Vcs-Browser: https://salsa.debian.org/science-team/xeus-python
Rules-Requires-Root: no

Package: xeus-python-dev
Architecture: any
Depends: ${misc:Depends},
         libxeus-python0 (= ${binary:Version}),
         xeus-zmq-dev,
         pybind11-dev,
         pybind11-json-dev,
         python3-dev,
Description: Native jupyter kernel for python (headers)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the development headers.

Package: libxeus-python0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: libs
Description: Native jupyter kernel for python (library)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the library.

Package: xpython
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3-xeus-python-shell,
Description: Native jupyter kernel for python (binary)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the xpython executable and jupyter kernel configuration.

Package: python3-xeus-python-shell
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: Native jupyter kernel for python (python library)
 xeus-python uses the xeus library to provide a high-performance,
 native kernel for running python code in the jupyter notebook,
 or other frontends using the jupyter messaging protocol.
 .
 This package contains the python library used for the shell.
