=== debian/changelog ===
xeus-python (0.17.2+~0.6.3-0.2) unstable; urgency=medium

  * Non-maintainer upload by request from Gordon.
  * debian/control:
   - Remove Build-Depends on xtl-dev
   - Build-Depends on nlohmann-json3.12-dev instead of nlohmann-json3-dev

 -- Bill Allombert <ballombe@debian.org>  Sun, 02 Nov 2025 10:54:03 +0100

xeus-python (0.17.2+~0.6.3-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Bill Allombert <ballombe@debian.org>  Fri, 27 Dec 2024 11:29:11 +0100

xeus-python (0.17.1+~0.6.3-0.2) experimental; urgency=medium

  * Non-maintainer upload.
  * debian/control: add Build-Depends on xeus-dev (>= 5.0.0)

 -- Bill Allombert <ballombe@debian.org>  Fri, 01 Nov 2024 20:31:52 +0100

xeus-python (0.17.1+~0.6.3-0.1) experimental; urgency=medium

  * Non-maintainer upload by request from Gordon.
    - patch no-install-dot-cmake: do no install the .cmake files.
  * debian/control:
    - Build-Depends on pkgconf instead of pkg-config
    - Build-Depends on xeus-zmq-dev (>= 3.0.0)
    - remove useless packages xeus-python-dev and libxeus-python0.
  * debian/xeus-python-dev.install, debian/libxeus-python0.install:
    removed.
  * debian/rules:
    - add override_dh_clean to fix clean target
    - dh_auto_configure:
      + set -DXPYT_USE_SHARED_XEUS_PYTHON=OFF -DXPYT_BUILD_SHARED=OFF
        to disable building libxeus-python0
      + set -DPYTHON_VERSION_MAJOR=3 -DPYTHON_VERSION_MINOR=11
        to get correct version in kernel.json
  * debian/copyright:
    - update path to SVG images.
    - use public-domain as SPDX identifier for Public domain.

 -- Bill Allombert <ballombe@debian.org>  Fri, 01 Nov 2024 11:45:27 +0100
