=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DPYTHON_EXECUTABLE=/usr/bin/python3 -DXPYT_DISABLE_ARCH_NATIVE=1 -DXPYT_DISABLE_TUNE_GENERIC=1 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DXPYT_USE_SHARED_XEUS_PYTHON=OFF -DXPYT_BUILD_SHARED=OFF -DPYTHON_VERSION_MAJOR=3 -DPYTHON_VERSION_MINOR=11
	dh_auto_configure -D xeus-python-shell --buildsystem pybuild

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -D xeus-python-shell --buildsystem pybuild

override_dh_auto_install:
	dh_auto_install
	dh_auto_install -D xeus-python-shell --buildsystem pybuild

override_dh_clean:
	dh_clean
	rm -f share/jupyter/kernels/xpython/kernel.json
	rm -f share/jupyter/kernels/xpython-raw/kernel.json
	rm -rf .pybuild
	rm -rf xeus-python-shell/xeus_python_shell.egg-info
