=== debian/tests/control ===
Test-Command: jupyter-nbconvert debian/tests/sample.ipynb --stdout --execute --to markdown
Depends: xpython, python3-ipython, python3-jupyter-client, jupyter-nbconvert
Restrictions: allow-stderr
