=== debian/watch ===
version=4
https://github.com/jupyter-xeus/xeus-python/tags .*/@ANY_VERSION@@ARCHIVE_EXT@ group

opts="component=xeus-python-shell" https://github.com/jupyter-xeus/xeus-python-shell/tags .*/@ANY_VERSION@@ARCHIVE_EXT@ group
