## xeus-python 0.17.6+~0.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,6 +27,86 @@
     ${XPYT_VERSION_MAJOR}.${XPYT_VERSION_MINOR}.${XPYT_VERSION_PATCH})
 message(STATUS "Building xeus-python v${${PROJECT_NAME}_VERSION}")
 
+# Build options
+# =============
+
+# Compilation options
+
+option(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
+
+option(XPYT_BUILD_STATIC "Build xeus-python static library" ON)
+option(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
+option(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
+option(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)
+
+option(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
+option(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
+
+option(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
+
+# Test options
+option(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
+
+function(cat IN_FILE OUT_FILE)
+  file(READ ${IN_FILE} CONTENTS)
+  file(APPEND ${OUT_FILE} "\n${CONTENTS}")
+endfunction()
+
+
+if(EMSCRIPTEN)
+    # Prepare a temporary file to "post.js.in" to
+    # merge xeus custom post js and the pyjs post js
+    file(WRITE post.js.in "")
+    cat(wasm_patches/post.js  post.js.in)
+
+    add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)
+    set_property(GLOBAL PROPERTY TARGET_SUPPORTS_SHARED_LIBS TRUE)
+
+    set(XPYT_BUILD_STATIC OFF)
+    set(XPYT_BUILD_SHARED OFF)
+    set(XPYT_BUILD_XPYTHON_EXECUTABLE OFF)
+    set(XPYT_BUILD_XPYTHON_EXTENSION OFF)
+    set(XPYT_USE_SHARED_XEUS_PYTHON OFF)
+    set(XPYT_BUILD_TESTS OFF)
+endif()
+
+# Dependencies
+# ============
+
+set(xeus_zmq_REQUIRED_VERSION 3.0.0)
+set(xeus-lite_REQUIRED_VERSION 1.0.1)
+set(pybind11_REQUIRED_VERSION 2.6.1)
+set(pybind11_json_REQUIRED_VERSION 0.2.8)
+set(pyjs_REQUIRED_VERSION 2.0.0)
+
+find_package(Python COMPONENTS Interpreter REQUIRED)
+
+if (NOT TARGET pybind11::headers)
+    # Defaults to ON for cmake >= 3.18
+    # https://github.com/pybind/pybind11/blob/35ff42b56e9d34d9a944266eb25f2c899dbdfed7/CMakeLists.txt#L96
+    set(PYBIND11_FINDPYTHON OFF)
+    find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
+endif ()
+if (NOT TARGET pybind11_json)
+    find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
+endif ()
+
+if(EMSCRIPTEN)
+    if (NOT TARGET xeus-lite)
+        find_package(xeus-lite ${xeus-lite_REQUIRED_VERSION} REQUIRED)
+    endif ()
+    if (NOT TARGET pyjs)
+        find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
+    endif ()
+    configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
+    cat(${pyjs_POST_JS_PATH}  post.js.in)
+    configure_file( post.js.in  ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
+else ()
+    if (NOT TARGET xeus-zmq AND NOT TARGET xeus-zmq-static)
+        find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
+    endif ()
+endif()
+
 # Configuration
 # =============
 
@@ -34,6 +114,16 @@
 
 if (NOT DEFINED XPYTHON_KERNELSPEC_PATH)
     set(XPYTHON_KERNELSPEC_PATH "${CMAKE_INSTALL_FULL_BINDIR}/")
+endif ()
+
+if (NOT DEFINED XPYTHON_DEBUGGER_AVAILABLE)
+    message(STATUS "PYTHON_VERSION = ${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}")
+    if ((PYTHON_VERSION_MAJOR EQUAL 3) AND (PYTHON_VERSION_MINOR EQUAL 13))
+        set(XPYTHON_DEBUGGER_AVAILABLE "false")
+    else ()
+        set(XPYTHON_DEBUGGER_AVAILABLE "true")
+    endif ()
+    message(STATUS "XPYTHON_DEBUGGER_AVAILABLE=${XPYTHON_DEBUGGER_AVAILABLE}")
 endif ()
 
 if(EMSCRIPTEN)
@@ -44,96 +134,23 @@
     STRING(REGEX MATCH "python[0-9]+[.][0-9]+" PYTHON_VERSION_STRING ${WASM_PYTHON_LIBRARY})
     STRING(REGEX MATCH "[0-9]+" PYTHON_VERSION_MAJOR ${PYTHON_VERSION_STRING})
     STRING(REGEX MATCH "[0-9]+$" PYTHON_VERSION_MINOR ${PYTHON_VERSION_STRING})
+
+    configure_file (
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/wasm_kernel.json.in"
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
+    )
+else()
+    configure_file (
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
+    )
+    configure_file (
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json.in"
+        "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json"
+    )
 endif()
 
-configure_file (
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json.in"
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython/kernel.json"
-)
-configure_file (
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json.in"
-    "${CMAKE_CURRENT_SOURCE_DIR}/share/jupyter/kernels/xpython-raw/kernel.json"
-)
-
-# Build options
-# =============
-
-# Compilation options
-
-option(XPYT_ENABLE_PYPI_WARNING "Enable warning on PyPI wheels" OFF)
-
-option(XPYT_BUILD_STATIC "Build xeus-python static library" ON)
-option(XPYT_BUILD_SHARED "Split xpython build into executable and library" ON)
-option(XPYT_BUILD_XPYTHON_EXECUTABLE "Build the xpython executable" ON)
-option(XPYT_BUILD_XPYTHON_EXTENSION "Build the xpython extension module" OFF)
-
-option(XPYT_USE_SHARED_XEUS "Link xpython or xpython_extension with the xeus shared library (instead of the static library)" ON)
-option(XPYT_USE_SHARED_XEUS_PYTHON "Link xpython and xpython_extension with the xeus-python shared library (instead of the static library)" ON)
-
-option(XPYT_EMSCRIPTEN_WASM_BUILD "Build for wasm with emscripten" OFF)
-
-# Test options
-option(XPYT_BUILD_TESTS "xeus-python test suite" OFF)
-
-function(cat IN_FILE OUT_FILE)
-  file(READ ${IN_FILE} CONTENTS)
-  file(APPEND ${OUT_FILE} "\n${CONTENTS}")
-endfunction()
-
-
-if(EMSCRIPTEN)
-    # Prepare a temporary file to "post.js.in" to
-    # merge xeus custom post js and the pyjs post js
-    file(WRITE post.js.in "")
-    cat(wasm_patches/post.js  post.js.in)
-
-    add_compile_definitions(XPYT_EMSCRIPTEN_WASM_BUILD)
-
-    set(XPYT_BUILD_STATIC OFF)
-    set(XPYT_BUILD_SHARED OFF)
-    set(XPYT_BUILD_XPYTHON_EXECUTABLE OFF)
-    set(XPYT_BUILD_XPYTHON_EXTENSION OFF)
-    set(XPYT_USE_SHARED_XEUS OFF)
-    set(XPYT_USE_SHARED_XEUS_PYTHON OFF)
-    set(XPYT_BUILD_TESTS OFF)
-endif()
-
-# Dependencies
-# ============
-
-set(xeus_zmq_REQUIRED_VERSION 3.0.0)
-set(xeus-lite_REQUIRED_VERSION 1.0.1)
-set(pybind11_REQUIRED_VERSION 2.6.1)
-set(pybind11_json_REQUIRED_VERSION 0.2.8)
-set(pyjs_REQUIRED_VERSION 2.0.0)
-
-find_package(Python COMPONENTS Interpreter REQUIRED)
-
-if (NOT TARGET pybind11::headers)
-    # Defaults to ON for cmake >= 3.18
-    # https://github.com/pybind/pybind11/blob/35ff42b56e9d34d9a944266eb25f2c899dbdfed7/CMakeLists.txt#L96
-    set(PYBIND11_FINDPYTHON OFF)
-    find_package(pybind11 ${pybind11_REQUIRED_VERSION} REQUIRED)
-endif ()
-if (NOT TARGET pybind11_json)
-    find_package(pybind11_json ${pybind11_json_REQUIRED_VERSION} REQUIRED)
-endif ()
-
-if(EMSCRIPTEN)
-    if (NOT TARGET xeus-lite)
-        find_package(xeus-lite ${xeus-lite_REQUIRED_VERSION} REQUIRED)
-    endif ()
-    if (NOT TARGET pyjs)
-        find_package(pyjs ${pyjs_REQUIRED_VERSION} REQUIRED)
-    endif ()
-    configure_file(${pyjs_PRE_JS_PATH} ${CMAKE_CURRENT_BINARY_DIR}/pre.js COPYONLY)
-    cat(${pyjs_POST_JS_PATH}  post.js.in)
-    configure_file( post.js.in  ${CMAKE_CURRENT_BINARY_DIR}/post.js COPYONLY)
-else ()
-    if (NOT TARGET xeus-zmq AND NOT TARGET xeus-zmq-static)
-        find_package(xeus-zmq ${xeus-zmq_REQUIRED_VERSION} REQUIRED)
-    endif ()
-endif()
+
 
 # Source files
 # ============
@@ -293,7 +310,7 @@
                                $<INSTALL_INTERFACE:include>)
 
     if (EMSCRIPTEN)
-        set(XPY_XEUS_TARGET xeus)
+        set(XPYT_XEUS_TARGET xeus)
     elseif (XPYT_USE_SHARED_XEUS)
         set(XPYT_XEUS_TARGET xeus-zmq)
     else ()
@@ -330,20 +347,3 @@
 
 if (XPYT_BUILD_STATIC)
     # On Windows, a static library should use a different output name
-    # to avoid the conflict with the import library of a shared one.
-    if (CMAKE_HOST_WIN32)
-        xpyt_create_target(xeus-python-static "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" STATIC xeus-python-static)
-    else ()
-        xpyt_create_target(xeus-python-static "${XEUS_PYTHON_SRC}" "${XEUS_PYTHON_HEADERS}" STATIC xeus-python)
-    endif ()
-
-    list(APPEND XEUS_PYTHON_TARGETS xeus-python-static)
-endif ()
-
-if (EMSCRIPTEN)
-    xpyt_create_target(xeus-python-wasm "${XEUS_PYTHON_WASM_SRC}" "${XEUS_PYTHON_WASM_HEADERS}" STATIC xeus-python-wasm)
-    target_compile_options(xeus-python-wasm PRIVATE -fPIC)
-    list(APPEND XEUS_PYTHON_TARGETS xeus-python-wasm)
-
-    target_link_libraries(xeus-python-wasm PRIVATE pyjs)
-
