=== debian/changelog ===
xeus-python (0.17.6+~0.6.4-1) unstable; urgency=medium

  * New upstream version 0.17.6+~0.6.4
  * d/patches: rebase
  * d/control: standards-version 4.7.3, drop rules-requires-root, drop priority
  * d/rules: do not hardcode PYTHON_VERSION_MINOR
  * d/watch: upgrade to version 5

 -- Gordon Ball <gordon@chronitis.net>  Tue, 30 Dec 2025 14:16:39 +0000
