=== debian/watch ===
Version: 5

Template: GitHub
Owner: jupyter-xeus
Project: xeus-python
Version-Schema: group

Component: xeus-python-shell
Template: GitHub
Owner: jupyter-xeus
Project: xeus-python-shell
Version-Schema: group
